#include <rtems/thread.h>

extern rtems_recursive_mutex dhcpcd_mutex;

#define add_options dhcpcd_add_options
#define arp_announce dhcpcd_arp_announce
#define arp_probe dhcpcd_arp_probe
#define arp_start dhcpcd_arp_start
#define carrier_status dhcpcd_carrier_status
#define check_ipv6 dhcpcd_check_ipv6
#define clock_monotonic dhcpcd_clock_monotonic
#define daemonise dhcpcd_daemonise
#define decode_rfc3361 dhcpcd_decode_rfc3361
#define decode_rfc3397 dhcpcd_decode_rfc3397
#define decode_rfc3442 dhcpcd_decode_rfc3442
#define decode_rfc5969 dhcpcd_decode_rfc5969
#define dev_load dhcpcd_dev_load
#define dhcp6_addrexists dhcpcd_dhcp6_addrexists
#define dhcp6_drop dhcpcd_dhcp6_drop
#define dhcp6_env dhcpcd_dhcp6_env
#define dhcp6_find_delegates dhcpcd_dhcp6_find_delegates
#define dhcp6_free dhcpcd_dhcp6_free
#define dhcp6_handleifa dhcpcd_dhcp6_handleifa
#define dhcp6_opts dhcpcd_dhcp6_opts
#define dhcp6_opts_len dhcpcd_dhcp6_opts_len
#define dhcp6_printoptions dhcpcd_dhcp6_printoptions
#define dhcp6_reboot dhcpcd_dhcp6_reboot
#define dhcp6_start dhcpcd_dhcp6_start
#define dhcp_auth_encode dhcpcd_dhcp_auth_encode
#define dhcp_auth_validate dhcpcd_dhcp_auth_validate
#define dhcp_bind dhcpcd_dhcp_bind
#define dhcp_close dhcpcd_dhcp_close
#define dhcp_decline dhcpcd_dhcp_decline
#define dhcp_discover dhcpcd_dhcp_discover
#define dhcp_drop dhcpcd_dhcp_drop
#define dhcp_dump dhcpcd_dhcp_dump
#define dhcp_env dhcpcd_dhcp_env
#define dhcp_envoption dhcpcd_dhcp_envoption
#define dhcp_free dhcpcd_dhcp_free
#define dhcp_handleifa dhcpcd_dhcp_handleifa
#define dhcp_inform dhcpcd_dhcp_inform
#define dhcp_message_add_addr dhcpcd_dhcp_message_add_addr
#define dhcp_message_new dhcpcd_dhcp_message_new
#define dhcp_opts dhcpcd_dhcp_opts
#define dhcp_opts_len dhcpcd_dhcp_opts_len
#define dhcp_printoptions dhcpcd_dhcp_printoptions
#define dhcp_reboot_newopts dhcpcd_dhcp_reboot_newopts
#define dhcp_start dhcpcd_dhcp_start
#define dhcp_xid dhcpcd_dhcp_xid
#define dhcp_zero_index dhcpcd_dhcp_zero_index
#define discover_interfaces dhcpcd_discover_interfaces
#define do_mtu dhcpcd_do_mtu
#define duid dhcpcd_duid
#define duid_init dhcpcd_duid_init
#define duid_len dhcpcd_duid_len
#define eloop_event_add dhcpcd_eloop_event_add
#define eloop_event_delete dhcpcd_eloop_event_delete
#define eloop_q_timeout_add_sec dhcpcd_eloop_q_timeout_add_sec
#define eloop_q_timeout_add_tv dhcpcd_eloop_q_timeout_add_tv
#define eloop_q_timeout_delete dhcpcd_eloop_q_timeout_delete
#define eloop_q_timeouts_delete dhcpcd_eloop_q_timeouts_delete
#define eloop_start dhcpcd_eloop_start
#define eloop_timeout_add_now dhcpcd_eloop_timeout_add_now
#define encode_rfc1035 dhcpcd_encode_rfc1035
#define find_interface dhcpcd_find_interface
#define free_dhcp_opt_embenc dhcpcd_free_dhcp_opt_embenc
#define free_interface dhcpcd_free_interface
#define free_options dhcpcd_free_options
#define get_hostname dhcpcd_get_hostname
#define getifssid dhcpcd_getifssid
#define get_lease dhcpcd_get_lease
#define get_line dhcpcd_get_line
#define get_monotonic dhcpcd_get_monotonic
#define get_option_addr dhcpcd_get_option_addr
#define get_option_routes dhcpcd_get_option_routes
#define get_option_string dhcpcd_get_option_string
#define handle_args dhcpcd_handle_args
#define handle_carrier dhcpcd_handle_carrier
#define handle_hwaddr dhcpcd_handle_hwaddr
#define handle_interface dhcpcd_handle_interface
#define hardware_platform dhcpcd_hardware_platform
#define hwaddr_aton dhcpcd_hwaddr_aton
#define hwaddr_ntoa dhcpcd_hwaddr_ntoa
#define ifac dhcpcd_ifac
#define ifaces dhcpcd_ifaces
#define if_address6 dhcpcd_if_address6
#define if_address dhcpcd_if_address
#define ifav dhcpcd_ifav
#define if_conf dhcpcd_if_conf
#define ifdc dhcpcd_ifdc
#define ifdv dhcpcd_ifdv
#define if_init dhcpcd_if_init
#define if_options dhcpcd_if_options
#define if_route6 dhcpcd_if_route6
#define if_route dhcpcd_if_route
#define if_vimaster dhcpcd_if_vimaster
#define in6_addr_flags dhcpcd_in6_addr_flags
#define inet_cidrtoaddr dhcpcd_inet_cidrtoaddr
#define inet_ntocidr dhcpcd_inet_ntocidr
#define ipv4_addrexists dhcpcd_ipv4_addrexists
#define ipv4_applyaddr dhcpcd_ipv4_applyaddr
#define ipv4_buildroutes dhcpcd_ipv4_buildroutes
#define ipv4_findaddr dhcpcd_ipv4_findaddr
#define ipv4_free dhcpcd_ipv4_free
#define ipv4_freeroutes dhcpcd_ipv4_freeroutes
#define ipv4_getnetmask dhcpcd_ipv4_getnetmask
#define ipv4_getrawpacket dhcpcd_ipv4_getrawpacket
#define ipv4_handleifa dhcpcd_ipv4_handleifa
#define ipv4_init dhcpcd_ipv4_init
#define ipv4ll_handle_failure dhcpcd_ipv4ll_handle_failure
#define ipv4ll_start dhcpcd_ipv4ll_start
#define ipv4_opensocket dhcpcd_ipv4_opensocket
#define ipv4_routedeleted dhcpcd_ipv4_routedeleted
#define ipv4_sendrawpacket dhcpcd_ipv4_sendrawpacket
#define ipv6_addaddr dhcpcd_ipv6_addaddr
#define ipv6_addlinklocalcallback dhcpcd_ipv6_addlinklocalcallback
#define ipv6_buildroutes dhcpcd_ipv6_buildroutes
#define ipv6_dadtransmits dhcpcd_ipv6_dadtransmits
#define ipv6_findaddr dhcpcd_ipv6_findaddr
#define ipv6_free dhcpcd_ipv6_free
#define ipv6_freedrop_addrs dhcpcd_ipv6_freedrop_addrs
#define ipv6_free_ll_callbacks dhcpcd_ipv6_free_ll_callbacks
#define ipv6_handleifa_addrs dhcpcd_ipv6_handleifa_addrs
#define ipv6_handleifa dhcpcd_ipv6_handleifa
#define ipv6_init dhcpcd_ipv6_init
#define ipv6_linklocal dhcpcd_ipv6_linklocal
#define ipv6_makeaddr dhcpcd_ipv6_makeaddr
#define ipv6_makeprefix dhcpcd_ipv6_makeprefix
#define ipv6_mask dhcpcd_ipv6_mask
#define ipv6nd_addrexists dhcpcd_ipv6nd_addrexists
#define ipv6nd_cancelprobeaddr dhcpcd_ipv6nd_cancelprobeaddr
#define ipv6nd_cancelproberouter dhcpcd_ipv6nd_cancelproberouter
#define ipv6nd_drop dhcpcd_ipv6nd_drop
#define ipv6nd_env dhcpcd_ipv6nd_env
#define ipv6nd_expirera dhcpcd_ipv6nd_expirera
#define ipv6nd_free dhcpcd_ipv6nd_free
#define ipv6nd_freedrop_ra dhcpcd_ipv6nd_freedrop_ra
#define ipv6nd_handleifa dhcpcd_ipv6nd_handleifa
#define ipv6nd_has_ra dhcpcd_ipv6nd_has_ra
#define ipv6nd_probeaddr dhcpcd_ipv6nd_probeaddr
#define ipv6nd_probeaddrs dhcpcd_ipv6nd_probeaddrs
#define ipv6nd_proberouter dhcpcd_ipv6nd_proberouter
#define ipv6nd_startrs dhcpcd_ipv6nd_startrs
#define ipv6_prefixlen dhcpcd_ipv6_prefixlen
#define ipv6_printaddr dhcpcd_ipv6_printaddr
#define ipv6_removesubnet dhcpcd_ipv6_removesubnet
#define ipv6_routers dhcpcd_ipv6_routers
#define ipv6_userprefix dhcpcd_ipv6_userprefix
#define make_message dhcpcd_make_message
#define make_option_mask dhcpcd_make_option_mask
#define manage_link dhcpcd_manage_link
#define open_link_socket dhcpcd_open_link_socket
#define open_sockets dhcpcd_open_sockets
#define options dhcpcd_options
#define print_option dhcpcd_print_option
#define print_string dhcpcd_print_string
#define read_config dhcpcd_read_config
#define read_lease dhcpcd_read_lease
#define script_runreason dhcpcd_script_runreason
#define select_profile dhcpcd_select_profile
#define set_cloexec dhcpcd_set_cloexec
#define set_nonblock dhcpcd_set_nonblock
#define setvard dhcpcd_setvard
#define setvar dhcpcd_setvar
#define socket_afnet dhcpcd_socket_afnet
#define sort_interfaces dhcpcd_sort_interfaces
#define start_interface dhcpcd_start_interface
#define up_interface dhcpcd_up_interface
#define uptime dhcpcd_uptime
#define vendor dhcpcd_vendor
#define vivso dhcpcd_vivso
#define vivso_find dhcpcd_vivso_find
#define vivso_len dhcpcd_vivso_len
#define write_lease dhcpcd_write_lease
#define writepid dhcpcd_writepid
